﻿  UseJPEGImageDecoder()
  UseJPEGImageEncoder()



IncludeFile "Check Ogg.pbi"
IncludeFile "Oggvorbis.pbi"
IncludeFile "dlgSelectImage.pbi"
IncludeFile "dlgChooseComment.pbi"

Global NewList EditTags.OGGvorbis::tag()
Global ImageTag.OGGvorbis::tag


Global winMain

Global ImageContainer, Image_0, btnPrevious, btnNext, btnAddImage, btnDeleteImage, TagEditor, TagList, btnSaveTag, btnDeleteTag, ComboTags, btnNewTag, btnLoadFile, btnSaveFile, btnCancel

Global CurrentFile.s,FileToCheck.s,ImageFile.s,ImageID.i,NewPicture.i,Changed.i

Global Info.OGGvorbis::VorbisPictureInfo

Enumeration FormMenu
  #mnuLoad
  #mnuSave
  #mnuQuit
  #mnuCheck
EndEnumeration

Procedure SaveComments()
  
  ; Define CommentString.s,CommentLength.s
  Define BufferSize.i,BufferPosition.i
  Define OutFile.i

  BufferSize = 7 + (5 * ListSize(EditTags()))
  
  ForEach EditTags()
    
    If EditTags()\Title = "VENDOR"
      BufferSize = BufferSize + Len(EditTags()\Value)
    ElseIf EditTags()\Type = 1
      BufferSize = BufferSize + Len("METADATA_BLOCK_PICTURE" + "=" + EditTags()\Value)
    Else
      
      BufferSize = BufferSize + Len(EditTags()\Title + "=" + EditTags()\Value)
    EndIf

  Next
  
   BufferSize + 1
  
  *Mem = AllocateMemory(BufferSize)  
  
  BufferPosition = 0
  ;vorbis header
  PokeA(*Mem + BufferPosition,3)
  BufferPosition + 1
  PokeS(*Mem + BufferPosition,"vorbis",6,#PB_Ascii|#PB_String_NoZero)
  BufferPosition + 6
  
  ForEach EditTags()
          
    If EditTags()\Title = "VENDOR"
                
      result =  Len(EditTags()\Value)
      PokeL(*Mem + BufferPosition,Result)
      BufferPosition + 4
      PokeS(*Mem + BufferPosition,EditTags()\Value,result,#PB_UTF8|#PB_String_NoZero)
      BufferPosition + result
      
      ;Number Of Comments
      PokeL(*Mem + BufferPosition,ListSize(EditTags()) - 1)
      BufferPosition + 4
                  
    ElseIf EditTags()\Type = 1
      
      result =  Len("METADATA_BLOCK_PICTURE" + "=" + EditTags()\Value)
      PokeL(*Mem + BufferPosition,Result)
      BufferPosition + 4
      PokeS(*Mem + BufferPosition,"METADATA_BLOCK_PICTURE" + "=" + EditTags()\Value,result,#PB_UTF8|#PB_String_NoZero)
      BufferPosition + result
                  
    Else
                
      result =  Len(EditTags()\Title + "=" + EditTags()\Value)
      PokeL(*Mem + BufferPosition,Result)
      BufferPosition + 4
      PokeS(*Mem + BufferPosition,EditTags()\Title + "=" + EditTags()\Value,result,#PB_UTF8|#PB_String_NoZero)
      BufferPosition + result
      
    EndIf
                
  Next
            
  PokeA(*Mem + BufferPosition,1)
            
  ;Write File
  OutFile = CreateFile(#PB_Any,"vorbis 2.tmp")
  WriteData(OutFile,*mem,BufferSize)
  CloseFile(OutFile)
            
  OGGvorbis::SaveOGGFile()
                      
  FreeMemory(*Mem)
            
EndProcedure

Procedure LoadFile(FileName.s)
  
  Define BackupFile.s,ImageCount.i
    
  ;Copy File To Working Folder As Backup
  BackupFile = "Working\" + GetFilePart(FileName)
  CopyFile(FileName,BackupFile)
  
  OGGvorbis::LoadOGGFile(FileName)
  OGGvorbis::GetComments()
  
  ClearGadgetItems(TagEditor)
  ClearGadgetItems(TagList)
  ClearList(EditTags())
  Changed = #False
  NewPicture = 0  
  
  ;Clear The Image
  StartDrawing(CanvasOutput(Image_0))
  Box(0,0,250,250,RGB(255,255,255))
  StopDrawing()
  
  ImageCount = 1
  
  ForEach OGGvorbis::SongTags()
 
    AddElement(EditTags())
    EditTags()\Title = OGGvorbis::SongTags()\Title
    EditTags()\Value = OGGvorbis::SongTags()\Value
    
    ;Never Show Vendor Tag
    If OGGvorbis::SongTags()\Title <> "VENDOR"  

      If OGGvorbis::SongTags()\Title = "METADATA_BLOCK_PICTURE"
        
        ;EditTags()\Title = "Picture " + Str(ImageCount)
        ImageCount + 1
        EditTags()\ImageID =  OGGvorbis::DecodeVorbisPicture(OGGvorbis::SongTags()\Value, @Info)
        EditTags()\Type = 1

        Select Info\Type
            
            Case 3
            
              EditTags()\Title = "Front Cover Image"
 
            Case 4
              
              EditTags()\Title = "Back Cover Image"
              
            Case 7
            
              EditTags()\Title = "Artist Image"
 
            Case 8
              
              EditTags()\Title = "Performer Image"             
              
            Default
              
              EditTags()\Title = "Unknown Image" 
              
              
        EndSelect
        
        
        AddGadgetItem(TagList,-1,EditTags()\Title)
        
        Select Info\type
            
            
        EndSelect

      Else
      
        AddGadgetItem(TagList,-1,OGGvorbis::SongTags()\Title)     
      
      EndIf    
 
    EndIf
    
  Next 

EndProcedure

  Define ImageCancel.i,NewComment.s

  winMain = OpenWindow(#PB_Any, 0, 0, 760, 360, "Ogg vorbis Comment Editor", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  
  CreateMenu(#PB_Any, WindowID(winMain))
  MenuTitle("Songs")
  MenuItem(#mnuLoad, "Load")
  MenuItem(#mnuSave, "Save")
  MenuBar()
  MenuItem(#mnuQuit, "Exit")
  MenuTitle("Tools")
  MenuItem(#mnuCheck, "Check Song")  
  Image_0 = CanvasGadget(#PB_Any, 500, 10, 250, 250)
  btnAddImage = ButtonGadget(#PB_Any, 500, 298, 70, 25, "Add")
  btnDeleteImage = ButtonGadget(#PB_Any, 580, 298, 70, 25, "Delete")
  TagEditor = EditorGadget(#PB_Any, 240, 10, 250, 279,#PB_Editor_WordWrap)
  TagList = ListViewGadget(#PB_Any, 10, 10, 220, 279)
  btnAddTag = ButtonGadget(#PB_Any, 10, 298, 70, 25, "Add Tag")
  btnDeleteTag = ButtonGadget(#PB_Any, 90, 298, 70, 25, "Delete Tag")
  btnSaveTag = ButtonGadget(#PB_Any, 240, 298, 70, 25, "Save Tag") 
  
  ;Create Working Folder
  CreateDirectory("Working")
  
Repeat
    
    Event = WaitWindowEvent()
    Select Event
      Case #PB_Event_CloseWindow
        
        If Changed = #True
          If MessageRequester("Unsaved Changes","There are changes not saved to the music file! Save changes?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning) = #PB_MessageRequester_Yes
            SaveComments()
            CloseFile(#PB_All)
          EndIf
        EndIf        
    
        End

    Case #PB_Event_Menu
      Select EventMenu()
          
        Case   #mnuLoad

          CurrentFile = OpenFileRequester("Please choose ogg file", "", "Song Files (*.ogg)|*.ogg", 0)

          If CurrentFile
            
            SetWindowTitle(winMain,"Ogg vorbis Comment Editor - " + GetFilePart(CurrentFile))

            LoadFile(CurrentFile)
            
          EndIf         
          
        Case   #mnuSave
          
          SaveComments()
          
          CloseFile(#PB_All)
          
          LoadFile(CurrentFile)
          
        Case   #mnuQuit
          
          If Changed = #True
            
            If MessageRequester("Unsaved Changes","There are changes not saved to the music file! Save changes?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning) = #PB_MessageRequester_Yes
              SaveComments()
              CloseFile(#PB_All)
            EndIf
          EndIf
                    
          ;Close Everything
          CloseWindow(winMain)
          End          
          
        Case #mnuCheck
          
          FileToCheck = OpenFileRequester("Please choose ogg file", "", "Song Files (*.ogg)|*.ogg", 0)

          If FileToCheck

            If  CheckOGG::CheckFile(FileToCheck) = #True
              
              MessageRequester("Check OGG File","No Errors Found",#PB_MessageRequester_Ok|#PB_MessageRequester_Info)
              
            EndIf
            
            
          EndIf          
          
      EndSelect

    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case TagList
          
          ;Show selected tag in editor
          ClearGadgetItems(TagEditor)

          ForEach EditTags()
            If EditTags()\Title = GetGadgetText(TagList) 
              
              If EditTags()\Type = 1
                
                StartDrawing(CanvasOutput(Image_0))
                DrawImage(ImageID(EditTags()\ImageID),0,0,250,250)
                StopDrawing()                
                
              Else
                
                ;Clear The Image
                StartDrawing(CanvasOutput(Image_0))
                Box(0,0,250,250,RGB(255,255,255))
                StopDrawing()              
              
                AddGadgetItem(TagEditor,-1,EditTags()\Value)
                
              EndIf
              
              Break
            EndIf
          Next        
          
          
        Case btnAddTag
          
          InList = #False
          
          NewComment = ChooseComment::Open()
          
          If NewComment <> ""
            ForEach EditTags()
              If EditTags()\Title = NewComment
                InList = #True
                Break
              EndIf
            Next           
            If Inlist = #False
              Changed = #True
              AddGadgetItem(TagList,-1,NewComment)
              AddElement(EditTags())
              EditTags()\Title = NewComment
              EditTags()\Value = "Unknown"
            EndIf
          EndIf
          
        Case btnDeleteTag

          ForEach EditTags()
            If EditTags()\Title = GetGadgetText(TagList)
              If EditTags()\Type = 0
                Changed = #True
                DeleteElement(EditTags())
              EndIf
              Break
            EndIf
          Next         
          
        Case btnSaveTag
          
          ForEach EditTags()
            If EditTags()\Title = GetGadgetText(TagList) 
              Changed = #True
              EditTags()\Value = GetGadgetText(TagEditor)
              Break
            EndIf
          Next
          
        Case btnAddImage
          
          ImageTag\Type = 0
          ImageTag\ImageID = -1
          ImageTag\Title = ""
          ImageTag\Value = ""
          SelectImage::Open(@ImageTag)
          
          ImageCancel = #False          
          
          If ImageTag\ImageID > 0
            
            ForEach EditTags()
              
              If FindString(ImageTag\Title,EditTags()\Title) > 0
                
                If  MessageRequester("Information","Image Exists! Click Yes to Replace Click No to Cancel",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning) = #PB_MessageRequester_Yes

                  DeleteElement(EditTags())

                Else
                  
                  ImageCancel = #True

                EndIf

              EndIf
              
            Next
            
            If ImageCancel = #False
              Changed = #True
              AddElement(EditTags())
              EditTags()\Title = ImageTag\Title
              EditTags()\Value = ImageTag\Value
              EditTags()\ImageID = ImageTag\ImageID
              EditTags()\Type = ImageTag\Type 
              
              ClearGadgetItems(TagList)
              ForEach EditTags()
                If EditTags()\Title <> "VENDOR"
                  AddGadgetItem(Taglist,-1,EditTags()\Title)
                EndIf
              Next
 
            EndIf
  
          EndIf
          
        Case btnDeleteImage          
          
          ForEach EditTags()
            If EditTags()\Title = GetGadgetText(TagList)  
              If EditTags()\Type = 1
                Changed = #True
                FreeImage(EditTags()\ImageID)
                DeleteElement(EditTags())
                RemoveGadgetItem(TagList,GetGadgetState(TagList))
                ;Clear The Image
                StartDrawing(CanvasOutput(Image_0))
                Box(0,0,250,250,RGB(255,255,255))
                StopDrawing()
                Break
              EndIf
            EndIf
          Next     
          
          
      EndSelect
  EndSelect
  
ForEver

DataSection
  Tags:  
  Data.s "ALBUM","ARTIST","TITLE","VERSION","LYRICS","COMMENT","TRACKNUMBER","PERFORMER","COPYRIGHT","LICENSE","ORGANIZATION","DESCRIPTION","GENRE","DATE","LOCATION","CONTACT","ISRC","END"
EndDataSection  
  
; IDE Options = PureBasic 5.71 beta 3 LTS (Windows - x64)
; CursorPosition = 382
; FirstLine = 378
; Folding = -
; EnableXP