﻿
DeclareModule SelectImage
  
  UseJPEGImageDecoder()
  
  Structure tag
    Title.s
    Value.s
    ImageID.i
  EndStructure
  
  Declare.i Open(*ImageTag.OggVorbis::tag)
  
EndDeclareModule


Module SelectImage
  

Global dlgImageSelect

Global imgSelected, ImgTypeCombo, txtSelectType, btnSelect, btnOk, btnCancel


Procedure.i Open(*ImageTag.OGGvorbis::tag)
  
  Define Event.i,Quit.i,RetVal.i,ImageID,ImageType
  Define Type.s,ImageFile.s
  
  dlgImageSelect = OpenWindow(#PB_Any, 0, 0, 420, 260, "Select Picture", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  imgSelected = ImageGadget(#PB_Any, 5, 5, 250, 250, 0, #PB_Image_Border)
  ImgTypeCombo = ComboBoxGadget(#PB_Any, 260, 39, 150, 24)
  txtSelectType = TextGadget(#PB_Any, 260, 10, 144, 20, "Select Image Type")
  btnSelect = ButtonGadget(#PB_Any, 260, 77, 70, 24, "Select")
  btnOk = ButtonGadget(#PB_Any, 265, 221, 70, 24, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 345, 221, 70, 24, "Cancel")
  
  Quit = #False
  
  
  i = 0
  AddGadgetItem(ImgTypeCombo,i,"Front Cover")
  SetGadgetItemData(ImgTypeCombo,i,3)
  i + 1
  AddGadgetItem(ImgTypeCombo,i,"Back Cover")
  SetGadgetItemData(ImgTypeCombo,i,4)
  i + 1
  AddGadgetItem(ImgTypeCombo,i,"Artist")
  SetGadgetItemData(ImgTypeCombo,i,7)
  i+ 1
  AddGadgetItem(ImgTypeCombo,i,"Performer")
  SetGadgetItemData(ImgTypeCombo,i,8)  

  
  
  
  Repeat
      
      Event = WaitWindowEvent()
      Select Event
        Case #PB_Event_CloseWindow
          Quit = #True
  
      Case #PB_Event_Menu
        Select EventMenu()
        EndSelect
  
      Case #PB_Event_Gadget
        
        Select EventGadget()
            
          Case ImgTypeCombo
            
            ImageType =  GetGadgetItemData(ImgTypeCombo,GetGadgetState(ImgTypeCombo))
             
          Case btnSelect
            
            ImageFile = OpenFileRequester("Please choose jpg file", "", "Picture Files (*.jpg)|*.jpg", 0)
            ImageID = LoadImage(#PB_Any, ImageFile)
          
            ResizeImage(ImageID,250,250)
            
            SetGadgetState(imgSelected,ImageID(ImageID))
            
          Case btnOk
            
            If ImageType > 0
            
            If IsImage(ImageID)

              *ImageTag\ImageID = ImageID
              *ImageTag\Title = GetGadgetText(ImgTypeCombo) + " Image"
              *ImageTag\Type = 1
              *ImageTag\Value = OGGvorbis::EncodeVorbisPicture(ImageID,ImageType)

              Quit = #True
              CloseWindow(dlgImageSelect)             
              
            Else
              
              ;Message
              ;No Image

            EndIf
            
          Else
            
            ;message Image Type
            
          EndIf
          
            
            
            
          Case btnCancel
            
            Quit = #True
            Retval = -1
            CloseWindow(dlgImageSelect)
            
        EndSelect
    EndSelect
    
  Until Quit = #True
  
  ProcedureReturn RetVal
  
EndProcedure

DataSection 
  ImageTypes:
  Data.s "Front Cover","Back Cover","Lead Artist","Performer","Artist Logo","END"
  
EndDataSection  
  
;Image Types
;0 - Other
;1 - 32x32 pixels 'file icon' (PNG only)
;2 - Other file icon
;3 - Cover (front)
;4 - Cover (back)
;5 - Leaflet page
;6 - Media (e.g. label side of CD)
;7 - Lead artist/lead performer/soloist
;8 - Artist/performer
;9 - Conductor
;10 - Band/Orchestra
;11 - Composer
;12 - Lyricist/text writer
;13 - Recording Location
;14 - During recording
;15 - During performance
;16 - Movie/video screen capture
;17 - A bright coloured fish
;18 - Illustration
;19 - Band/artist logotype
;20 - Publisher/Studio logotype
EndModule


; IDE Options = PureBasic 5.71 beta 3 LTS (Windows - x64)
; CursorPosition = 158
; FirstLine = 128
; Folding = -
; EnableXP